function varargout = configuremenu(varargin)
% CONFIGUREMENU M-file for configuremenu.fig
%      CONFIGUREMENU, by itself, creates a new CONFIGUREMENU or raises the existing
%      singleton*.
%
%      H = CONFIGUREMENU returns the handle to a new CONFIGUREMENU or the handle to
%      the existing singleton*.
%
%      CONFIGUREMENU('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CONFIGUREMENU.M with the given input arguments.
%
%      CONFIGUREMENU('Property','Value',...) creates a new CONFIGUREMENU or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before configuremenu_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to configuremenu_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help configuremenu

% Last Modified by GUIDE v2.5 17-Dec-2007 19:08:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @configuremenu_OpeningFcn, ...
                   'gui_OutputFcn',  @configuremenu_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before configuremenu is made visible.
function configuremenu_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to configuremenu (see VARARGIN)

% Choose default command line output for configuremenu
handles.output = hObject;

handles.numberofcamera=1;
handles.count=1;
handles.configfile=['config.txt'];
set(handles.edit_numberofcamera,'String',handles.numberofcamera);


configmenu_setdefault();


% Update handles structure
guidata(hObject, handles);


% UIWAIT makes configuremenu wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = configuremenu_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%% ***********************************************************************
%% ***********************************************************************
function edit_numberofcamera_Callback(hObject, eventdata, handles)

handles.numberofcamera=str2double(get(handles.edit_numberofcamera,'String'));
if(handles.numberofcamera<=0 || handles.numberofcamera~=floor(handles.numberofcamera) || isnan(handles.numberofcamera))
   set(handles.edit_numberofcamera,'String',1);
   errordlg('Number of Camera has to be a positive integer!')
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_numberofcamera_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
   
%% % --- Executes on button press in pushbutton_storecamera.
function pushbutton_storecamera_Callback(hObject, eventdata, handles)


if handles.directory==0
    errordlg('Directory field empty!');
else    
    set(handles.edit_numberofcamera,'Enable','off');
    
    if(handles.count==1) 
        fo=fopen(handles.configfile,'w');
        fprintf(fo,'Total Numbers of Camera: %d\n',handles.numberofcamera);
        fprintf(fo,'\n');
        fclose(fo);
    end  
    
    if(handles.count < handles.numberofcamera)

        writeconfig;
        
        handles.count=handles.count+1;
        
        set(handles.text2,'String',num2str(handles.count));  
        configmenu_setdefault();

        guidata(hObject, handles);
    else       
        writeconfig;
        
        configmenu_setdefault();
        guidata(hObject, handles);

        pushbutton_EXIT_Callback(hObject, eventdata, handles);
        menu1();
    end

end
%% % --- Executes on button press in pushbutton_reset.
function pushbutton_reset_Callback(hObject, eventdata, handles)

configmenu_setdefault();

guidata(hObject, handles);
%%
function edit_directory_Callback(hObject, eventdata, handles)

handles.directory=(get(handles.edit_directory,'String'));

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_directory_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% % --- Executes on button press in pushbutton_browse.
function pushbutton_browse_Callback(hObject, eventdata, handles)

if handles.directory==0
        handles.directory=uigetdir([pwd '\Images']);
    else    
        handles.directory=uigetdir(handles.directory);
    end

    if handles.directory==0
        set(handles.edit_directory,'String',[]);
    else    
        set(handles.edit_directory,'String',handles.directory);
    end

    guidata(hObject, handles);

%%
function edit_nameimage_Callback(hObject, eventdata, handles)

    handles.nameimage=get(handles.edit_nameimage,'String');
    guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_nameimage_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% % --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)

start=get(hObject,'Value')-1;
if start<10
    handles.start(1,:)=['0',num2str(start)];
else
    handles.start(1,:)=num2str(start);
end
    guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:23]);

%% % --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)

start=get(hObject,'Value')-1;
if start<10
    handles.start(2,:)=['0',num2str(start)];
else
    handles.start(2,:)=num2str(start);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)

start=get(hObject,'Value')-1;
if start<10
    handles.start(3,:)=['0',num2str(start)];
else
    handles.start(3,:)=num2str(start);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu4.
function popupmenu4_Callback(hObject, eventdata, handles)

frequency=get(hObject,'Value')-1;
if frequency<10
    handles.frequency(1,:)=['0',num2str(frequency)];
else
    handles.frequency(1,:)=num2str(frequency);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:23]);

%% % --- Executes on selection change in popupmenu5.
function popupmenu5_Callback(hObject, eventdata, handles)

frequency=get(hObject,'Value')-1;
if frequency<10
    handles.frequency(2,:)=['0',num2str(frequency)];
else
    handles.frequency(2,:)=num2str(frequency);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu5_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu6.
function popupmenu6_Callback(hObject, eventdata, handles)

frequency=get(hObject,'Value')-1;
if frequency<10
    handles.frequency(3,:)=['0',num2str(frequency)];
else
    handles.frequency(3,:)=num2str(frequency);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu6_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu7.
function popupmenu7_Callback(hObject, eventdata, handles)

finish=get(hObject,'Value')-1;
if finish<10
    handles.finish(1,:)=['0',num2str(finish)];
else
    handles.finish(1,:)=num2str(finish);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu7_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:23]);

%% % --- Executes on selection change in popupmenu8.
function popupmenu8_Callback(hObject, eventdata, handles)

finish=get(hObject,'Value')-1;
if finish<10
    handles.finish(2,:)=['0',num2str(finish)];
else
    handles.finish(2,:)=num2str(finish);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu8_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu9.
function popupmenu9_Callback(hObject, eventdata, handles)

finish=get(hObject,'Value')-1;
if finish<10
    handles.finish(3,:)=['0',num2str(finish)];
else
    handles.finish(3,:)=num2str(finish);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu9_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu10.
function popupmenu10_Callback(hObject, eventdata, handles)

dailyfrequency=get(hObject,'Value')-1;
if dailyfrequency<10
    handles.dailyfrequency(1,:)=['0',num2str(dailyfrequency)];
else
    handles.dailyfrequency(1,:)=num2str(dailyfrequency);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu10_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
set(hObject,'String',[0:1:23]);

%% % --- Executes on selection change in popupmenu11.
function popupmenu11_Callback(hObject, eventdata, handles)

dailyfrequency=get(hObject,'Value')-1;
if dailyfrequency<10
    handles.dailyfrequency(2,:)=['0',num2str(dailyfrequency)];
else
    handles.dailyfrequency(2,:)=num2str(dailyfrequency);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu11_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);

%% % --- Executes on selection change in popupmenu12.
function popupmenu12_Callback(hObject, eventdata, handles)

dailyfrequency=get(hObject,'Value')-1;
if dailyfrequency<10
    handles.dailyfrequency(3,:)=['0',num2str(dailyfrequency)];
else
    handles.dailyfrequency(3,:)=num2str(dailyfrequency);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu12_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);
%% % --- Executes on selection change in popupmenu13.
function popupmenu13_Callback(hObject, eventdata, handles)

finishdtmx=get(hObject,'Value')-1;
if finishdtmx<10
    handles.finishdtmx(1,:)=['0',num2str(finishdtmx)];
else
    handles.finishdtmx(1,:)=num2str(finishdtmx);
end
    guidata(hObject, handles);

    % --- Executes during object creation, after setting all properties.
function popupmenu13_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:23]);
%% % --- Executes on selection change in popupmenu14.
function popupmenu14_Callback(hObject, eventdata, handles)

finishdtmx=get(hObject,'Value')-1;
if finishdtmx<10
    handles.finishdtmx(2,:)=['0',num2str(finishdtmx)];
else
    handles.finishdtmx(2,:)=num2str(finishdtmx);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu14_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);
%% % --- Executes on selection change in popupmenu15.
function popupmenu15_Callback(hObject, eventdata, handles)

finishdtmx=get(hObject,'Value')-1;
if finishdtmx<10
    handles.finishdtmx(3,:)=['0',num2str(finishdtmx)];
else
    handles.finishdtmx(3,:)=num2str(finishdtmx);
end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu15_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',[0:1:59]);
%% % --- Executes on selection change in popupmenu_dateformat.
function popupmenu_dateformat_Callback(hObject, eventdata, handles)

    handles.dateformat=get(hObject,'Value');
%%%    handles.dateformat=content{get(hObject,'Value')};
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu_dateformat_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set(hObject,'String',['DDMMYY';'YYMMDD']);

%% % --- Executes on button press in pushbutton_EXIT.
function pushbutton_EXIT_Callback(hObject, eventdata, handles)

closeapl();






function edit_separator_Callback(hObject, eventdata, handles)
% hObject    handle to edit_separator (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_separator as text
%        str2double(get(hObject,'String')) returns contents of edit_separator as a double

    handles.separator=(get(handles.edit_separator,'String'));

    guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_separator_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end