function varargout = menu_drow(varargin)
% MENU_DROW M-file for menu_drow.fig
%      MENU_DROW, by itself, creates a new MENU_DROW or raises the existing
%      singleton*.
%
%      H = MENU_DROW returns the handle to a new MENU_DROW or the handle to
%      the existing singleton*.
%
%      MENU_DROW('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MENU_DROW.M with the given input arguments.
%
%      MENU_DROW('Property','Value',...) creates a new MENU_DROW or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before menu_drow_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to menu_drow_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help menu_drow

% Last Modified by GUIDE v2.5 12-Jan-2008 19:33:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @menu_drow_OpeningFcn, ...
                   'gui_OutputFcn',  @menu_drow_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before menu_drow is made visible.
function menu_drow_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to menu_drow (see VARARGIN)

% Choose default command line output for menu_drow
handles.output = hObject;

menu_drow_setdefault();

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes menu_drow wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = menu_drow_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%% % --- Executes on selection change in popupmenu_camera.
function popupmenu_camera_Callback(hObject, eventdata, handles)

handles.camera=get(hObject,'Value')-1;

if (handles.camera>0)
    georeferentiationfile=['data\georef-camera' num2str(handles.camera) '.mat'];
   if (exist(georeferentiationfile,'file'))
       load(georeferentiationfile);
       handles.geo=geo;
        if (~isempty(handles.nameimage))
            set(handles.pushbutton_saveimage,'Enable','on');
            set(handles.pushbutton_selectpoint,'Enable','on');
            set(handles.pushbutton_export,'Enable','on');
            set(handles.pushbutton_zoomin,'Enable','on');
            set(handles.pushbutton_defaultview,'Enable','on');
            set(handles.edit_gbn,'Enable','on');
            set(handles.edit_gbe,'Enable','on');
            set(handles.text1,'Enable','on');
            set(handles.text2,'Enable','on');
            set(handles.popupmenu2,'Enable','on');
        end        
    else
        str=['Camera ' int2str(handles.camera) ' is not georeferentiated yet!'];
        warndlg(str, 'Warning');
        menu_rectify_setdefault();                
    end
else
    menu_drow_setdefault();
end

guidata(hObject, handles);
% --- Executes during object creation, after setting all properties.
function popupmenu_camera_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

fo=fopen('config.txt','r');
numberofcamera=parseline(fgetl(fo),'num');
fclose(fo);

str_camera=repmat('Camera ',numberofcamera,1);
str_numberofcamera=[1:1:numberofcamera]';

popup_str=[str_camera num2str(str_numberofcamera)]; 

spaces=repmat(' ',1,1+size(num2str(numberofcamera),2));
strall=['CAMERA' spaces];
popup_str=[strall ; popup_str];

set(hObject,'String',popup_str);
%%
function edit_gbn_Callback(hObject, eventdata, handles)

handles.gbn=str2double(get(handles.edit_gbn,'String'));
if(handles.gbn <= 0 || isnan(handles.gbn))
   handles.gbn=[]; 
   set(handles.edit_gbn,'String',[]);
   errordlg('Gauss-Boaga N has to be a positive integer!')
end

if(~isempty(handles.gbe))
    radiobuttonyes=get(handles.radiobutton_yes,'Value');
    coord2point(handles.gbn,handles.gbe,handles.geo,radiobuttonyes,handles.RECT(1),handles.RECT(2));

    handles.gbe=[];
    handles.gbn=[];
    set(handles.edit_gbe,'String',[]);
    set(handles.edit_gbn,'String',[]);
end

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_gbn_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% 
function edit_gbe_Callback(hObject, eventdata, handles)

handles.gbe=str2double(get(handles.edit_gbe,'String'));
if(handles.gbe <= 0 || isnan(handles.gbe))
   handles.gbe=[]; 
   set(handles.edit_gbe,'String',[]);
   errordlg('Gauss-Boaga E has to be a positive integer!')
end

if(~isempty(handles.gbn))
    radiobuttonyes=get(handles.radiobutton_yes,'Value');
    coord2point(handles.gbn,handles.gbe,handles.geo,radiobuttonyes,handles.RECT(1),handles.RECT(2));
    
    handles.gbe=[];
    handles.gbn=[];
    set(handles.edit_gbe,'String',[]);
    set(handles.edit_gbn,'String',[]);
end

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_gbe_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% % --- Executes on button press in pushbutton_loadimage.
function pushbutton_loadimage_Callback(hObject, eventdata, handles)
global I;
global nameimage;
[nameimage,location]=uigetfile('*.jpg', 'Choose image...');
handles.nameimage=nameimage;

I=imread([location nameimage]); 
[handles.geo.pixelrow,handles.geo.pixelcol]=size(I(:,:,1));

imshow(I);

% HD=get(handles.axes1,'Children');
% set(HD,'ButtonDownFcn','picclick');
georeferentiationfile=['data\georef-camera' num2str(handles.camera) '.mat'];
      
if (handles.camera>0 & exist(georeferentiationfile,'file'))
    set(handles.pushbutton_saveimage,'Enable','on');
    set(handles.pushbutton_selectpoint,'Enable','on');
    set(handles.pushbutton_export,'Enable','on');
    set(handles.pushbutton_zoomin,'Enable','on');
    set(handles.pushbutton_defaultview,'Enable','on');
    set(handles.edit_gbn,'Enable','on');
    set(handles.edit_gbe,'Enable','on');
    set(handles.text1,'Enable','on');
    set(handles.text2,'Enable','on');
    set(handles.popupmenu2,'Enable','on');
end

guidata(hObject, handles);
%% % --- Executes on button press in pushbutton_selectpoint.
function pushbutton_selectpoint_Callback(hObject, eventdata, handles)

[col row]=my_getpts(get(handles.axes1,'Parent'));

handles.row=floor(row(1,1)+handles.RECT(2));
handles.col=floor(col(1,1)+handles.RECT(1));

hold on 
plot(handles.col-handles.RECT(1),handles.row-handles.RECT(2),'r.');
hold off

radiobuttonyes=get(handles.radiobutton_yes,'Value');
if(radiobuttonyes==1)
   handles.gbn=handles.geo.GBNret(handles.row,handles.col);
   handles.gbe=handles.geo.GBEret(handles.row,handles.col);
else
   handles.gbn=handles.geo.GBN(handles.row,handles.col);
   handles.gbe=handles.geo.GBE(handles.row,handles.col);    
end
    
set(handles.edit_gbe,'String',num2str(handles.gbe));
set(handles.edit_gbn,'String',num2str(handles.gbn));

guidata(hObject, handles);
%% % --- Executes on button press in pushbutton_export.
function pushbutton_export_Callback(hObject, eventdata, handles)

radiobuttonyes=get(handles.radiobutton_yes,'Value');
    if radiobuttonyes==1
        GBN=handles.geo.GBNret;
        GBE=handles.geo.GBEret;
    else
        GBN=handles.geo.GBN;
        GBE=handles.geo.GBE;
    end
    
cd export
[savefile,savepath] = uiputfile('*.dat','Save curve as...');
cd ..
while (exist([savefile '.dat'],'file')==2 & savefile~=0),
	button = questdlg('The file already exists: do you want to replace it?',...
            'Warning','Yes','No','No');
    if  strcmp(button,'No')
    	[savefile,savepath] = uiputfile('*.dat','Save curve as...');
    else 
    	break;
    end
end

if (savefile~=0)  
    fo=fopen([savepath savefile '.dat'],'w');
    coldrw=handles.coldrw;
    rowdrw=handles.rowdrw;
    while(~isempty(rowdrw))
        fprintf(fo,'%d  %d\n',coldrw(1),coldrw(1));
        for it = 2 : coldrw(1)+1
            fprintf(fo,'%.3f  %.3f\n',GBN(rowdrw(it),coldrw(it)),GBE(rowdrw(it),coldrw(it)));
        end

        coldrw(1:coldrw(1)+1)=[];
        rowdrw(1:rowdrw(1)+1)=[];    
    end
    fclose(fo);
end

guidata(hObject, handles);
%% % --- Executes on button press in pushbutton_reset.
function pushbutton_reset_Callback(hObject, eventdata, handles)

menu_drow_setdefault();

guidata(hObject, handles);
%% % --- Executes on button press in pushbutton_zoomin.
function pushbutton_zoomin_Callback(hObject, eventdata, handles)
global I;
RECT=round(getrect(gcf));

imshow(I(RECT(2):RECT(2)+RECT(4),RECT(1):RECT(1)+RECT(3),:));

handles.RECT=RECT;

    coldrw_temp=handles.coldrw;
    rowdrw_temp=handles.rowdrw;
    hold on
    while(~isempty(coldrw_temp))
        plot(coldrw_temp(2:coldrw_temp(1)+1)-handles.RECT(1),rowdrw_temp(2:rowdrw_temp(1)+1)-handles.RECT(2),'r');
        coldrw_temp(1:coldrw_temp(1)+1)=[];
        rowdrw_temp(1:rowdrw_temp(1)+1)=[];
    end
    hold off

guidata(hObject, handles);
%% % --- Executes on button press in pushbutton_defaultview.
function pushbutton_defaultview_Callback(hObject, eventdata, handles)
global I;
handles.RECT=[0 0 0 0];

imshow(I);

    coldrw_temp=handles.coldrw;
    rowdrw_temp=handles.rowdrw;
    hold on
    while(~isempty(coldrw_temp))
        plot(coldrw_temp(2:coldrw_temp(1)+1)-handles.RECT(1),rowdrw_temp(2:rowdrw_temp(1)+1)-handles.RECT(2),'r');
        coldrw_temp(1:coldrw_temp(1)+1)=[];
        rowdrw_temp(1:rowdrw_temp(1)+1)=[];
    end
    hold off

guidata(hObject, handles);
%% % --- Executes on button press in pushbutton_back.
function pushbutton_back_Callback(hObject, eventdata, handles)

closeapl();
menu1();
%% % --- Executes on button press in pushbutton_exit.
function pushbutton_exit_Callback(hObject, eventdata, handles)

closeapl();







%% % --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2

popupvalue=get(hObject,'Value');

if popupvalue==2
    handles.coldrw1=[];
    handles.rowdrw1=[];
    
    [coldrw1 rowdrw1]=myline_getpts(get(handles.axes1,'Parent'));
    
    coldrw1=floor(coldrw1+handles.RECT(1));
    rowdrw1=floor(rowdrw1+handles.RECT(2));

    handles.coldrw1=[handles.coldrw1 ; coldrw1];
    handles.rowdrw1=[handles.rowdrw1 ; rowdrw1];
    
    
    handles.coldrw=[handles.coldrw; length(handles.coldrw1); handles.coldrw1];
    handles.rowdrw=[handles.rowdrw; length(handles.rowdrw1); handles.rowdrw1];


    hold on
    plot(handles.coldrw1-handles.RECT(1),handles.rowdrw1-handles.RECT(2),'r')
    hold off        
elseif popupvalue==3
    indexto=length(handles.coldrw);
    if indexto == 0

        handles.coldrw1=[];
        handles.rowdrw1=[];

        [coldrw1 rowdrw1]=myline_getpts(get(handles.axes1,'Parent'));

        coldrw1=floor(coldrw1+handles.RECT(1));
        rowdrw1=floor(rowdrw1+handles.RECT(2));

        handles.coldrw1=[handles.coldrw1 ; coldrw1];
        handles.rowdrw1=[handles.rowdrw1 ; rowdrw1];


        handles.coldrw=[handles.coldrw; length(handles.coldrw1); handles.coldrw1];
        handles.rowdrw=[handles.rowdrw; length(handles.rowdrw1); handles.rowdrw1];


        hold on
        plot(handles.coldrw1-handles.RECT(1),handles.rowdrw1-handles.RECT(2),'r')
        hold off        

    else
    
        indexfrom=indexto-length(handles.coldrw1);

        handles.coldrw([indexfrom:1:indexto])=[];
        handles.rowdrw([indexfrom:1:indexto])=[];

        [coldrw1 rowdrw1]=myline_getpts(get(handles.axes1,'Parent'));

        coldrw1=floor(coldrw1+handles.RECT(1));
        rowdrw1=floor(rowdrw1+handles.RECT(2));

        handles.coldrw1=[handles.coldrw1 ; coldrw1];
        handles.rowdrw1=[handles.rowdrw1 ; rowdrw1];


        handles.coldrw=[handles.coldrw; length(handles.coldrw1); handles.coldrw1];
        handles.rowdrw=[handles.rowdrw; length(handles.rowdrw1); handles.rowdrw1];


        hold on
        plot(handles.coldrw1-handles.RECT(1),handles.rowdrw1-handles.RECT(2),'r')
        hold off
    end
elseif popupvalue==4
    radiobuttonyes=get(handles.radiobutton_yes,'Value');
%    load_and_drow_data(handles.geo,radiobuttonyes,handles.RECT(1),handles.RECT(2));
    handles=load_and_drow_data(hObject, eventdata, handles,radiobuttonyes);
end


guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

popup_str{1}=['LINE'];
popup_str{2}=['draw line'];
popup_str{3}=['continue line'];
popup_str{4}=['load line'];

set(hObject,'String',popup_str);
guidata(hObject, handles);

%%
%%
%%
%%

function[]=coord2point(gbn,gbe,geo,radiobuttonyes,handlesRECT1,handlesRECT2)

    GBN=gbn-geo.gbn0;
    GBE=gbe-geo.gbe0;


    if(radiobuttonyes==1)
            coeff=inv([1,1;geo.pixelrow,1])*[geo.gbnmax;geo.gbnmin];
            row=(GBN-coeff(2))./coeff(1);
    
            coeff=inv([1,1;geo.pixelcol,1])*[geo.gbemin;geo.gbemax];
            col=(GBE-coeff(2))./coeff(1);

            if col<=geo.pixelcol & col>=0 & row>=0 & row<=geo.pixelrow
                hold on
                plot(col-handlesRECT1,row-handlesRECT2,'r.');
                hold off
            else
                warndlg('The selected pont is out of range','Pixell...');               
            end
    else
            col=(geo.L(1)*GBN+geo.L(2)*GBE+geo.L(4))./(geo.L(9)*GBN+geo.L(10)*GBE +1);
            row=(geo.L(5)*GBN+geo.L(6)*GBE+geo.L(8))./(geo.L(9)*GBN+geo.L(10)*GBE +1);
            if col<=geo.pixelcol & col>=0 & row>=0 & row<=geo.pixelrow
                hold on
                plot(col-handlesRECT1,row-handlesRECT2,'r.');
                hold off
            else
                warndlg('The selected pont is out of range','Pixell...');
            end
    end        
%%
%%
%function[]=load_and_drow_data(geo,radiobuttonyes,handlesRECT1,handlesRECT2)
function[handles]=load_and_drow_data(hObject, eventdata, handles,radiobuttonyes)

geo=handles.geo;

cd export
[namedata,pathdata] = uigetfile('*.dat','Select images'); 
cd ..
if namedata~=0,

    fid = fopen([pathdata namedata]);
    coord0 = fscanf(fid,'%g %g',[2 inf]);
    coord0 = coord0';
    fclose(fid);

    colloadedold=[];
    rowloadedold=[];
    colloadedretold=[];
    rowloadedretold=[];
    
    while(~isempty(coord0))
        coord=coord0(2:coord0(1)+1,:);

        GBNloaded=coord(:,1)-geo.gbn0;
        GBEloaded=coord(:,2)-geo.gbe0;

        colloaded=(geo.L(1)*GBNloaded+geo.L(2)*GBEloaded+geo.L(4))./(geo.L(9)*GBNloaded+geo.L(10)*GBEloaded +1);
        rowloaded=(geo.L(5)*GBNloaded+geo.L(6)*GBEloaded+geo.L(8))./(geo.L(9)*GBNloaded+geo.L(10)*GBEloaded +1);

        colloaded=[colloadedold;coord0(1);colloaded];
        rowloaded=[rowloadedold;coord0(1);rowloaded];    

        coeff=inv([1,1;geo.pixelrow,1])*[geo.gbnmax;geo.gbnmin];
        rowloadedret=(GBNloaded-coeff(2))./coeff(1);

        coeff=inv([1,1;geo.pixelcol,1])*[geo.gbemin;geo.gbemax];
        colloadedret=(GBEloaded-coeff(2))./coeff(1);;

        colloadedret=[colloadedretold;coord0(1);colloadedret];
        rowloadedret=[rowloadedretold;coord0(1);rowloadedret];    

        coord0(1:coord0(1)+1,:)=[];

        colloadedold=colloaded;
        rowloadedold=rowloaded;
        colloadedretold=colloadedret;
        rowloadedretold=rowloadedret;
    end
    
    if radiobuttonyes==1
        coldrw=colloadedret;
        rowdrw=rowloadedret;
    else
        coldrw=colloaded;
        rowdrw=rowloaded;
    end

    coldrw_temp=coldrw;
    rowdrw_temp=rowdrw;
    hold on
    while(~isempty(coldrw_temp))
        plot(coldrw_temp(2:coldrw_temp(1)+1)-handles.RECT(1),rowdrw_temp(2:rowdrw_temp(1)+1)-handles.RECT(2),'r');
        coldrw_temp(1:coldrw_temp(1)+1)=[];
        rowdrw_temp(1:rowdrw_temp(1)+1)=[];
    end
    hold off
end


    handles.coldrw=[handles.coldrw; floor(coldrw)];
    handles.rowdrw=[handles.rowdrw; floor(rowdrw)];


guidata(hObject, handles);


% --- Executes on button press in pushbutton_saveimage.
function pushbutton_saveimage_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_saveimage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


children = get(handles.axes1,'Children');
map = colormap; 
fig=figure('Visible','off'); 

lengthchildren=size(children,1);
 for it = lengthchildren:-1:1
    ch1 = children(it);
    prop = get(ch1); 
    switch prop.Type 
        case 'line' 
            plot(prop.XData,prop.YData,'Color',prop.Color,... 
                'LineStyle',prop.LineStyle,'LineWidth',prop.LineWidth, ... 
                'Marker',prop.Marker,'MarkerSize',prop.MarkerSize,... 
                'MarkerEdgeColor',prop.MarkerEdgeColor,... 
                'Visible',prop.Visible,... 
                'ButtonDownFcn',prop.ButtonDownFcn) 
        case 'image'
            image(prop.CData,'AlphaData',prop.AlphaData,'CDataMapping',prop.CDataMapping); 
            hold on
    end 
 end 
hold off
colormap(map) 
%set(gcf,'Visible','on'); 
axis off

set(gca,'Position', [0 0 1 1]);

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear savefile
clear savepath

[savefile,savepath] = uiputfile('*.jpg','Save Image As...');

    while (exist([savefile '.jpg'],'file')==2 & savefile~=0),
        button = questdlg('The file already exists: do you want to replace it?',...
            'Warning','Yes','No','No');
        if  strcmp(button,'No')
            [savefile,savepath] = uiputfile('*.jpg','Save Image As...');
        else 
            break;
        end
    end

if (savefile~=0)    
    saveas(fig,[savepath,savefile],'jpg');
else
    helpdlg('You Abort the Save','Warning');
end

close(fig);
